package es.upm.dit.adsw.tema2.day_0;

import java.util.Date;

public class Reloj
        implements Runnable {
    private final String id;
    private final int dt;
    private volatile boolean running;

    public Reloj(String id, int dt) {
        this.id = id;
        this.dt = dt;
    }

    @Override
    public void run() {
        running = true;
        while (running) {
            System.out.println(id + ": " + new Date());
            nap(dt * 1000);
        }
    }

    public void parar() {
        running = false;
    }

    private void nap(long ms) {
        try {
            Thread.sleep(ms);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}