package es.upm.dit.adsw.tema2.balls.d_narrow_bridge;

public class NB_Monitor_v3 extends NB_Monitor {
    private int nNS = 0;
    private int nSN = 0;
    private int npN = 0;
    private int npS = 0;

    public synchronized void entraN() {
        while (nSN > 0 || npS > 0)
            waiting();
        nNS++;
    }

    public synchronized void entraPrioritarioN() {
        npN++;
        while (nSN > 0)
            waiting();
        npN--;
        nNS++;
    }

    public synchronized void entraS() {
        while (nNS > 0 || npN > 0)
            waiting();
        nSN++;
    }

    public synchronized void entraPrioritarioS() {
        npS++;
        while (nNS > 0)
            waiting();
        npS--;
        nSN++;
    }

    public synchronized void saleN() {
        nSN--;
        notifyAll();
    }

    public synchronized void saleS() {
        nNS--;
        notifyAll();
    }

    private synchronized void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
