package es.upm.dit.adsw.tema2.bounded_buffer;

import java.util.Set;

public class TestProducer
        extends Thread {
    private final Buffer<Integer> buffer;
    private final Set<Integer> data;

    public TestProducer(Buffer<Integer> buffer, Set<Integer> data) {
        this.buffer = buffer;
        this.data = data;
    }

    @Override
    public void run() {
        try {
            for (Integer n : data) {
                buffer.put(n);
                Thread.sleep(100);
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println("producer ok");
    }
}
