package es.upm.dit.adsw.tema2.contador;

public class ContadorLento extends Thread {
    private ContadorCompartido cc;

    public ContadorLento(ContadorCompartido cc) {
        this.cc = cc;
    }

    @Override
    public void run() {
        int valor = cc.getN();
        valor++;
        nap((long) 1000);
        cc.setN(valor);
    }

    private void nap(long ms) {
        try {
            sleep(ms);
        } catch (InterruptedException ignored) {
        }
    }

    class ContadorCompartido {
        private int n = 0;

        int getN() {
            return n;
        }

        void setN(int n) {
            this.n = n;
        }
    }
}